UNIT Willi;



INTERFACE 


{********************** Maussteuerung ************************************}
Procedure MausIn;                          {Initialisierung der Maus}
Procedure MausAn;                          {Zeigt Maus-Cursor an}
Procedure MausStatus(Var x,y : Integer;    {Fragt Maus-Koordinaten ab}
                     Var Knopf : Word);
Procedure MausAus;                         { Schaltet Maus Aus}


{*********************** Druckersteuerung **********************************}
Function  PrinterOkay : Boolean;           { Gibt TRUE zurck, wenn der
                                             Drucker O.K. ist, dann hat der
                                             Drucker auch Papier und es liegen
                                             keine  Ein- & Ausgabe-  sowie
                                             Laufzeitfehler vor. }
Function DruckerStatus : byte;             { Gibt den aktuellen Status des
                                             Druckers zurck.

                 Definition des 'DruckerStatus' :

   -- 7 ---  ---- 6 ----  ---- 5 ----  -- 4 ---  ---- 3 ---  ---- 0 ---
   Nicht in               kein Papier            I/O Fehler  Zeitfehler
   Betrieb   Acknowledge               Selected  I/O Err.    Timed-out
}



{************************ Cursorsteuerung **********************************}
Procedure Cursor_Off;                      { Schaltet den Cursor aus}
Procedure Cursor_On;                       { Schaltet den Cursor an}
Procedure WartenAufTaste;                  { Wartet auf eine beliebig
                                             gedrckte Taste, auch Sonder-
                                             tasten!}
Procedure WartenAufTasteZwei;              { berprft ob Taste gedrckt
                                             wurde}


{***************************** Sound ***************************************}
Procedure Alarm_Eins;                      { Gibt Alarm bis eine Taste
                                             gedrckt wurde}
Procedure Click;                           { Macht einmal 'CLICK'}
Procedure Kuckuck;                         { No Coment !}
Procedure Sirene;                          { leckere, kleine Heule }
Procedure Siren;                           { noch'ne Heule }
Procedure Warnung;                         { Warntner}



{*************************** Sonstiges *************************************}
Procedure Telegramm;                       { Setzt fr jeden Buchstaben des
                                             Alphabetes und fr '', '' und
                                             '', die dazugehrigen Buch-
                                             stabier-Wrter, d.h. die Wrter,
                                             welche zum Beispiel bei der
                                             Telegrammversendung genutzt
                                             werden}
Procedure Kopiere_Datei;                   { Dieses Proggi benutzt die
                                             schnellen Blockoperationen von
                                             Turbo-PASCAL, um beliebige Files
                                             zu kopieren }
Procedure Monitor_Ganz_Dunkel;             { Schaltet Monitor dunkel }
Procedure Bildschirm_Wieder_An;            { Schaltet Monitor wieder an }
Function  Schreib_Schutz_Nein(Laufwerk : string): Boolean;

          { berprft ob das Laufwerk mit einem
            Schreibschutz versehen ist, oder nicht
            Wenn kein Schreibschutz, dann ist
            Schreib_Schutz_Nein:=true              }
Procedure Warmstart;                       { !!!! AUSPROBIEREN !!!!}


{@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}

IMPLEMENTATION



Uses Crt, Dos;


{######################################################}

Procedure MausIn;
Begin
  Asm
    Mov Ax,00H
    Int 33H
    Mov Ax,00H
    Int 33H
  End;
End;


Procedure MausAn;
Begin
  Asm
    Mov AX,001H
    Int 33H
  End;
End;


Procedure MausStatus(Var x,y   : Integer; Var Knopf : Word);
Var k      : Word;
    x1, y1 : Integer;
Begin
  Asm
    Mov Ax,03h
    Int 33H
    Mov k,bx
    Mov X1,cx
    Mov Y1,dx 
  end;
  Knopf:=k;
  x:=x1;
  y:=y1;
end;


Procedure MausAus;
Begin
  Asm
    Mov Ax,02H
    Int 33H
  End;
End;





{######################################################}

Function PrinterOkay : Boolean;
Var
  N, PrintStatus    : Byte;
  Regs : Registers;
Begin
  With Regs Do Begin
                 AH:=2;
                 DX:=0;
                 Intr($17,Regs);
                 PrintStatus:=AH;
               End;
  N:=PrintStatus;
  If ((N And $10)<>0) And ((N And $29)=0) Then PrinterOkay:=True
  Else PrinterOkay := False;
End;


Function DruckerStatus : byte;
Var
  Regs : Registers;
Begin
  With Regs Do Begin
    AH:=2;
    DX:=0;
    INTR($17,Regs);
    DruckerStatus:=ah;
  End;
End;






{######################################################}

Procedure Cursor_Off;
Begin
  ASM
     Xor AX,AX
     MOV Ah,01h
     MOV Ch,20h
     MOV Ch,20h
     Int 10h
  End;
End;


Procedure Cursor_On;
Begin
   ASM
     MOV Ah,01h
     MOV CX,0C0dh
     Int 10h
   end;
end;


Procedure WartenAufTaste;
Var  Status : Byte;
Begin
    Status := (Mem[$0000:$0417] And 176);
    Mem[$0000:$0417] := 32;
    Repeat Until (KeyPressed Or (Mem[$0000:$0417]<>32));
    Mem[$0000:$0417] := Status;
    Mem[$0000:1050] := Mem[$0000:1052];
End;


Procedure WartenAufTasteZwei;    
Begin
  Repeat Until port[$60]<$80;
End;



{######################################################}
Procedure Alarm_Eins;
Var
  X: Integer;
Begin
  While Not KeyPressed Do
  Begin
    For X:=440 To 2000 Do
      Sound(X);
    For X:= 2000 DownTo 440 Do
      Sound(X);
  End;
  NoSound;
End;


Procedure Click;

Var F,N : Integer;

Begin
  Sound(2000);
  Delay(5);
  NoSound;
End;


Procedure Kuckuck;
Begin;
  Sound (500);
  Delay (100);
  NoSound;
  Delay (100);
  Sound (300);
  Delay (100);
  NoSound;
  Delay (500);
End;


Procedure Sirene;
Var I : Integer;
Begin
  For I:=120 To 700 Do          
  Begin
    Sound(I);
    Delay(1);
  End;
  For I:= 700 DownTo 120 Do
  Begin
    Sound (I);
    Delay(1);
  End;
End;


Procedure Siren;
Var I,J : integer;
Begin
  For J := 1 To 20 Do
  Begin
    For I := 200 To 2300 Do sound(i);
    NoSound;
    Delay(100);
  End;
End;


Procedure Warnung;
Begin
  While Not KeyPressed Do
  Begin
    Sound(660);
    Delay(150);
    Sound(440);
    Delay(100);
    NoSound;
    Delay(800);
  End;
End;






{######################################################}
Procedure Telegramm;
Const
     a  = 'Anton';
     b  = 'Berta';
     c  = 'Csar';
     d  = 'Dora';
     e  = 'Emil';
     f  = 'Friedrich';
     g  = 'Gustav';
     h  = 'Heinrich';
     i  = 'Ida';
     j  = 'Julius';
     k  = 'Konrad';
     l  = 'Ludwig';
     m  = 'Martha';
     n  = 'Nordpol';
     o  = 'Otto';
     p  = 'Paula';
     q  = 'Quelle';
     r  = 'Richard';
     s  = 'Siegfried';
     t  = 'Theodor';
     u  = 'Ulrich';
     v  = 'Viktor';
     w  = 'Wilhelm';
     x  = 'Yanthippe';
     y  = 'Ypsilon';
     z  = 'Zeppelin';
     ae = 'rger';   {}
     ue = 'bel';    {}
     oe = 'dipus';  {}
Begin
End;


Procedure Kopiere_Datei;
Const
  ByteZahl=                  16384;    {128*128}
Var
  Quelle, Ziel:              File ;
  QuellName, ZielName:       String[14];
  Puffer:                    Array [1..ByteZahl] Of Byte;
  RecordZahl, Rest:          Integer;
Begin
  ClrScr;
  WriteLn('Name Zieldatei:');
  ReadLn(ZielName);
  Assign(Ziel,ZielName);
  Rewrite(Ziel,1);
  WriteLn('Name Quelldatei:');
  Readln(QuellName);
  Assign(Quelle,QuellName);
  Reset(Quelle,1);
  Rest:=FileSize(Quelle);
  While Rest > 0 Do
  Begin
    If ByteZahl <= Rest Then RecordZahl := Bytezahl Else RecordZahl := Rest;
    BlockRead(Quelle,Puffer,RecordZahl);
    BlockWrite(Ziel,Puffer,RecordZahl);
    Rest:=Rest-RecordZahl;
  End;
  Close(Quelle);
  Close(Ziel);
End;


Procedure Monitor_Ganz_Dunkel;
Begin
  ASM
    Mov AH,12H
    Mov BH,36H
    Mov AL,01H
    Int 10H
  End;
End;


Procedure Bildschirm_Wieder_An;
Begin
  ASM
    Mov AH,12H
    Mov BH,36H
    Mov AL,00H
    Int 10H
  End;
End;


Function Schreib_Schutz_Nein(Laufwerk : string): Boolean;
Var fFF: Text;
    OK : Boolean;
Begin
  Schreib_Schutz_Nein:=false;          
  Assign(fFF,Laufwerk+'test0.dat');
  {$I-}
  Rewrite(fFF);
  WriteLn(fFF,'gfgfsdhfds');
  Close(fFF);
  Erase(fFF);
  {$I+}
  If (IOResult=0) then
  Begin
    Schreib_Schutz_Nein:=True;
    OK                 :=True;
  End
  Else
  Begin
    Schreib_Schutz_Nein:=false;
    OK                 :=false;
  End;
End;


Procedure Warmstart;
Var ABC:Registers;
Begin
  Intr($19,ABC);           
End;







END.
